package com.payzippy.sdk;

import java.util.Arrays;
import java.util.List;

public class Constants
{
	public static final List<String> validPaymentMethods = Arrays.asList("CREDIT", "DEBIT", "EMI", "NET", "PAYZIPPY",
	        "CARD_CAPTURE");
	public static final List<String> bankNameRequirement = Arrays.asList("EMI", "NET");
	public static final List<String> uiModeRequirements = Arrays.asList("REDIRECT", "IFRAME");
	public static final List<String> hashMethodRequirements = Arrays.asList("SHA256", "MD5");

	public static final String MERCHANT_ID = "merchant_id";
	public static final String BUYER_EMAIL_ADDRESS = "buyer_email_address";
	public static final String MERCHANT_TRANSACTION_ID = "merchant_transaction_id";
	public static final String TRANSACTION_TYPE = "transaction_type";
	public static final String TRANSACTION_AMOUNT = "transaction_amount";

	public static final String PAYMENT_METHOD = "payment_method";
	public static final String BANK_NAME = "bank_name";
	public static final String EMI_MONTHS = "emi_months";
	public static final String CARD_CAPTURE = "card_capture";
	public static final String NAME_ON_CARD = "name_on_card";
	public static final String CARD_NUMBER = "card_number";
	public static final String CVV = "cvv";
	public static final String EXPIRY_MONTH = "expiry_month";
	public static final String EXPIRY_YEAR = "expiry_year";

	public static final String CURRENCY = "currency";
	public static final String UI_MODE = "ui_mode";
	public static final String HASH_METHOD = "hash_method";
	public static final String HASH = "hash";
	public static final String MERCHANT_KEY_ID = "merchant_key_id";
	public static final String BUYER_PHONE_NO = "buyer_phone_no";
	public static final String BUYER_UNIQUE_ID = "buyer_unique_id";
	public static final String SHIPPING_ADDRESS = "shipping_address";
	public static final String SHIPPING_CITY = "shipping_city";
	public static final String SHIPPING_STATE = "shipping_state";
	public static final String SHIPPING_ZIP = "shipping_zip";
	public static final String SHIPPING_COUNTRY = "shipping_country";
	public static final String SOURCE = "source";
	public static final String CALLBACK_URL = "callback_url";
	public static final String BILLING_NAME = "billing_name";
	public static final String BILLING_ADDRESS = "billing_address";
	public static final String BILLING_CITY = "billing_city";
	public static final String BILLING_STATE = "billing_state";
	public static final String BILLING_ZIP = "billing_zip";
	public static final String BILLING_COUNTRY = "billing_country";
	public static final String MIN_SLA = "min_sla";
	public static final String IS_USER_LOGGED_IN = "is_user_logged_in";
	public static final String ADDRESS_COUNT = "address_count";
	public static final String SALES_CHANNEL = "sales_channel";
	public static final String ITEM_TOTAL = "item_total";
	public static final String ITEM_VERTICAL = "item_vertical";
	public static final String TIMEGMT = "timegmt";
	public static final String UDF1 = "udf1";
	public static final String UDF2 = "udf2";
	public static final String UDF3 = "udf3";
	public static final String UDF4 = "udf4";
	public static final String UDF5 = "udf5";
	public static final String PAYZIPPY_TRANSACTION_ID = "payzippy_transaction_id";
	public static final String TRANSACTION_STATUS = "transaction_status";
	public static final String TRANSACTION_RESPONSE_CODE = "transaction_response_code";
	public static final String TRANSACTION_RESPONSE_MESSAGE = "transaction_response_message";
	public static final String TRANSACTION_CURRENCY = "transaction_currency";
	public static final String TRANSACTION_TIME = "transaction_time";
	public static final String FRAUD_ACTION = "fraud_action";
	public static final String FRAUD_DETAILS = "fraud_details";
	public static final String IS_INTERNATIONAL = "is_international";
	public static final String VERSION = "version";
	public static final String PAYZIPPY_SALE_TRANSACTION_ID = "payzippy_sale_transaction_id";
	public static final String REFUND_AMOUNT = "refund_amount";
	public static final String REFUND_REASON = "refund_reason";
	public static final String REFUNDED_BY = "refunded_by";
	public static final String STATUS_CODE = "status_code";
	public static final String STATUS_MESSAGE = "status_message";
	public static final String ERROR_CODE = "error_code";
	public static final String ERROR_MESSAGE = "error_message";
	public static final String REFUND_STATUS = "refund_status";
	public static final String REFUND_RESPONSE_CODE = "refund_response_code";
	public static final String REFUND_RESPONSE_MESSAGE = "refund_response_message";
	public static final String BANK_ARN = "bank_arn";
	public static final String TERMINAL_ID = "terminal_id";
	public static final String BANK_TRANSACTION_ID = "bank_transaction_id";
	public static final String DATA = "data";

	public static final int MERCHANT_ID_MAXLEN = 32;
	public static final int BUYER_EMAIL_ADDRESS_MAXLEN = 100;
	public static final int MERCHANT_TRANSACTION_ID_MAXLEN = 100;
	public static final int MERCHANT_KEY_ID_MAXLEN = 20;
	public static final int BUYER_PHONE_NO_MAXLEN = 50;
	public static final int BUYER_UNIQUE_ID_MAXLEN = 100;
	public static final int SHIPPING_ADDRESS_MAXLEN = 100;
	public static final int SHIPPING_CITY_MAXLEN = 50;
	public static final int SHIPPING_STATE_MAXLEN = 50;
	public static final int SHIPPING_ZIP_MAXLEN = 50;
	public static final int SHIPPING_COUNTRY_MAXLEN = 50;
	public static final int SOURCE_MAXLEN = 20;
	public static final int CALLBACK_URL_MAXLEN = 256;
	public static final int BILLING_NAME_MAXLEN = 255;
	public static final int BILLING_ADDRESS_MAXLEN = 100;
	public static final int BILLING_CITY_MAXLEN = 50;
	public static final int BILLING_STATE_MAXLEN = 50;
	public static final int BILLING_ZIP_MAXLEN = 50;
	public static final int BILLING_COUNTRY_MAXLEN = 50;
	public static final int MIN_SLA_MAXLEN = 100;
	public static final int ADDRESS_COUNT_MAXLEN = 100;
	public static final int SALES_CHANNEL_MAXLEN = 100;
	public static final int ITEM_TOTAL_MAXLEN = 100;
	public static final int ITEM_VERTICAL_MAXLEN = 100;
	public static final int TIMEGMT_MAXLEN = 13;
	public static final int UDF1_MAXLEN = 100;
	public static final int UDF2_MAXLEN = 100;
	public static final int UDF3_MAXLEN = 100;
	public static final int UDF4_MAXLEN = 100;
	public static final int UDF5_MAXLEN = 100;
	public static final int PAYZIPPY_TRANSACTION_ID_MAXLEN = 20;
	public static final int TRANSACTION_STATUS_MAXLEN = 30;
	public static final int TRANSACTION_RESPONSE_CODE_MAXLEN = 30;
	public static final int REFUND_AMOUNT_MAXLEN = 20;
	public static final int REFUNDED_BY_MAXLEN = 100;
	public static final int PAYZIPPY_SALE_TRANSACTION_ID_MAXLEN = 20;
	public static final int REFUND_REASON_MAXLEN = 512;

}
